open Ast
  
type var = string
exception UnboundVariable of var
    
(* A type for stores (aka variable environments) *)
type store = (var * int) list
      
      
(* Update binding for x in store s. Returns s[x->v] *)
let rec update(s, x, v) =
  match s with
  | [] -> [(x,v)]
  | (y,u)::t -> if x = y then (x,v)::t
  else (y,u)::update(t,x,v)
		
(* lookup(s, x) returns the binding for x in store s,       
   and raises UnboundVariable if no such variable exists. *)
let rec lookup(s, x) = 
  match s with
  |  [] -> raise (UnboundVariable x)
  |  (y,u)::t -> raise (Failure "unimplemented")
	
(* The evaluation function for commands. Takes command 
   c, and store s, and returns the resulting store.    *)
let rec evalc (c, s): store = 
  raise (Failure "unimplemented")

(* The evaluation function for arithmetic expressions. Takes expression 
   a, and store s, and returns the resulting int. *)
and evala(a, s): int = 
  raise (Failure "unimplemented")
    

(* The evaluation function for boolean expressions. Takes expression 
   b, and store s, and returns the resulting bool. *)
and evalb(b, s): bool = 
  raise (Failure "unimplemented")
